// app.ts
import { updateManager } from './utils/update'
import { Request } from './utils/http'
import { promisifyAll } from 'wx-promise-pro';
import utils from './utils/util';
import commonRequest from './utils/commonRequest';
import appModule from './modules/app';
import {websocketConnect} from './modules/websocket';
// @ts-ignore
const livePlayer = requirePlugin('live-player-plugin');
// import Dialog from '@vant/weapp/dialog/dialog';
// promisify all wx‘s api
promisifyAll()
// @ts-ignore
// @ts-ignore
// @ts-ignore
// @ts-ignore
App<IAppOption>({
  globalData: {
    themeColor: '#ff751a',
    scene:0,
    logoUrl:'',
    shopName:'家装巴士',
    FromUserId:'',
    OpenId:'',
    FromOpenId:'',
    loginData:{},
    settings:{},
    sellerList:[],
    AppId: wx.getExtConfigSync().AppId,
    TengXunMapLocationServiceKey: wx.getExtConfigSync().TengXunMapLocationServiceKey,
    indexCallback: ()=>{},
    detailSocketCallback: ()=>{}, // 详情页websocket消息
    manageSocketCallback: ()=>{}, // 活动管理页websocket消息
    hXSocketCallback: ()=>{}, // 核销页websocket消息
    socketMsgCallback: ()=>{}, // 通用websocket消息回调
  },
  async onLaunch(options) {
    this.globalData.scene = options.scene || '';
    // 版本管理
    updateManager();
    wx.$http = new Request();
    wx.$utils = utils;
    wx.$commonRequest = commonRequest;
    wx.$commonRequest.login = appModule.login;
    wx.globalData = this.globalData;


    appModule.handleOptions(options);
    this.globalData.isFirstOpenApp = true;

    // 第一次登录获取sessionid
    if (!await appModule.SetSessionId()) return;


    //wx.login
    if (!await appModule.login()) return;

    //websocket
    let loginData = this.globalData.loginData;
    if (loginData.dbId&&loginData.OpenId) websocketConnect();

    // 获取各类设置数据
    if (!await appModule.getSettingsData()) return;
    this.globalData.indexCallback();

    // 更新login会话
    setInterval(() => {
      appModule.login();
    }, 20 * 60 * 1000);

  },


  onShow(options) {
    console.log('发生了小程序app onShow事件', options);
    if (!this.globalData.isFirstOpenApp) {
      this.globalData.scene = options.scene || '';
      appModule.login();
      console.log('小程序非初次加载进入onShow，重新login一次');
      if (options.query.FromOpenId) {
        this.globalData.FromOpenId = options.query.FromOpenId;
        console.log('...小程序非初次加载进入onShow，FromOpenId更新为链接中的值 ',this.globalData.FromOpenId);
      }
      // return;
    }
    // if((options.scene == 1007 || options.scene == 1008 || options.scene == 1044)&&options.path.includes('/pages/live-player-plugin')){
    //   console.log('通过直播分享卡片进入小程序', options);
    //   livePlayer.getShareParams()
    //     .then((res:any)=>{
    //       console.log('获取直播 room id', res.room_id); // 房间号
    //       console.log('获取直播 openid', res.openid); // 用户openid
    //       console.log('获取直播 share openid', res.share_openid); // 分享者openid，分享卡片进入场景才有
    //       console.log('获取 custom params', res.custom_params); // 开发者在跳转进入直播间页面时，页面路径上携带的自定义参数，这里传回给开发者
    //       let FromUserId = res.custom_params.FromUserId || '';
    //       this.handleFromUserIdChange(FromUserId);
    //     }).catch((err:any) => {
    //     console.log('获取直播 share params', err)
    //   })
    // }
    // // 不是初次打开
    // else if(!this.globalData.isFirstOpenApp){
    //   let FromUserId = appModule.getFromUserId(options);
    //   this.handleFromUserIdChange(FromUserId);
    //
    // }
  },
  onHide () {
    this.globalData.isFirstOpenApp = false;
  },
})
